; DDS1.ASM
; Version 1.0 of July 15, 2003 
; DDS generator trial
; x-tal frequency 11999.55 kHz

; D0: D/A bit0
; D1: D/A bit1
; D2: D/A bit2
; D3: D/A bit3
; D4: D/A bit4
; D5: D/A bit5
; D6: D/A bit6
; B0: Display on/off switch
; B1: 7seg_a + dash paddle for freq--
; B2: 7seg_b + dot paddle for freq++
; B3: 7seg_c + speed or store
; B4: 7seg_d + display on
; B5: 7seg_e
; B6: 7seg_f
; B7: 7seg_g

.nolist
.include "1200def.inc"
.list

; main program register variables


.def    DDSreg0    =r0     ;DDS register 
.def    DDSreg1    =r1     ;DDS register 
.def    DDSreg2    =r2     ;DDS register 
.def    DDSreg3    =r3     ;DDS register 
.def    SUMreg0    =r4     ;Sum register =4544 * frequency in kHz
.def    SUMreg1    =r5     ;Sum register
.def    SUMreg2    =r6     ;Sum register
.def    SUMreg3    =r7     ;Sum register
.def	Selcnt_lo  =r8     ;Counter-lo for selection of switches
.def	Selcnt_hi  =r9     ;Counter-hi for selection of switches
.def    Zero       =r15    ;Zero

; >16 full instruction registers

.def    varX       =r16    ;General variable
.def    varY       =r17    ;General variable
.def    varZ       =r18    ;General variable
.def	Dispstate  =r19    ;Display status
.def	Speed      =r20    ;Tune speed
.def	Speedcnt   =r21    ;Counter for speed actions
.def	displaycnt =r22    ;Counter for display actions

.def	Display0   =r23	   ;less than 1 kHz, 0-63 is 0 - 1 kHz in 1000/64 steps
.def	Display1   =r24	   ;1 kHz
.def	Display2   =r25	   ;10 kHz
.def	Display3   =r26	   ;100 kHz
.def	Display4   =r27	   ;1 MHz
.def	Display5   =r28	   ;10 MHz
.def    Selection  =r29    ;Selection status


; code      


RESET:  ldi     varX,0b11111111  ;Set B1-7 to output
        out     DDRB,varX
        ldi     varX,0b00000000  ;All outputs 0
        out     PORTB,varX       ;Set outputs and pull up resistors
        ldi     varX,0b11111111  ;Set D0-D7 as output
        out     DDRD,varX

Clear_var:                       ;Clear all variables
        clr     varX             ;Make varX Zero
        ldi     ZL,29            ;From reg 29 to 0
Clear_varloop:
        st      Z,varX           ;Clear register with value in ZL (r30)
        dec     ZL               ;Decrement ZL (r30)
        brne    Clear_varloop    ;r30 not cleared, is ZL

Set_variables:
        ldi     Speed,5          ;Highest tune speed 100 kHz, lowest 15.625 Hz  
	
Initialize_freq:                 ;Freq = 4544 * freq (kHz) 
        ldi     varX,0x2         ;Store for 10120 MHz
        mov     SUMreg3,varX     ;MSB
        ldi     varx,0xBD
        mov     SUMreg2,varX
        ldi     varx,0xAE
        mov     SUMreg1,varX
        ldi     varx,0x0
        mov     SUMreg0,varX     ;LSB
	ldi	Display0,0
	ldi	Display1,0
	ldi	Display2,2
	ldi	Display3,1
	ldi	Display4,0
	ldi	Display5,1


;=============================================================================

Main_loop:
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
        nop	                 ;Time correction for 13 cycli
	nop	                 ;Time correction for 13 cycli
	inc     Selcnt_lo        ;Increment Selection counter_lo byte 
        brne    Main_loop        ;If not zero then Main_loop

        nop
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
        nop	                 ;Time correction for 13 cycli
        ldi     varY,20          ;Loop nX, here already initialized for Main_Sel_delay as here free cycle available
	inc     Selcnt_hi        ;Increment Selection counter_hi byte 
        brne    Main_loop        ;If not zero then Main_loop
        
Main_Selection:
        in	varZ,PORTB       ;Store PORTB
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
	ldi     varX,0b00000001  ;Set B0 output, B1-7 to input
        out     DDRB,varX
        ldi     varX,0b00000001  ;B0=1 for display off, B1-7 pull up resistors off
        out     PORTB,varX       ;Set pull up resistors

Main_Sel_delay:	
        nop
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD
        nop	                 ;Time correction for 13 cycli 
        dec	varY             ;Decrement delay counter
        brne    Main_Sel_delay   ;Loop if not zero
	
        in	Selection,PINB   ;Input switch settings
        com     Selection        ;Invert bits as a 0 is active
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
        ldi     varX,0b11111111  ;Set B0-7 to output
        out     DDRB,varX
        out     PORTB,varZ       ;Restore PORTB
   	andi	Selection,0b00011110  ;Test the input bits
	brne	Action

Main_reset_variables:            ;Reset variables if nothing selected
	add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
        ldi	Speedcnt,0       ;Reset Speedcnt if nothing selected
        ldi     varX,0b11111111  ;Set B0-7 to off state for LED
        out     PORTB,varx	 ;

        ldi	Displaycnt,0     ;Reset displaycnt if nothing selected
        ldi     Dispstate,0      ;Reset display status if nothing selected
	add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
        nop
        nop
	nop
	rjmp	Main_loop	 ;Goto mainloop

;=======================================================================


Action:
	sbrc	Selection,1      ;Tune a step down
	rcall	SubTuneL
	sbrc	Selection,2      ;Tune a step up
	rcall	SubTuneH
        sbrc	Selection,3      ;Change speed
	rjmp	SubSpeed
	sbrc	Selection,4      ;Display on
	rjmp	SubDisplay

	rjmp	Main_loop        


SubTuneL:
        ldi	Speedcnt,0       ;Reset Speedcnt if nothing selected
        ldi     varX,0b11111111  ;Set B0-7 to off state for LED
        out     PORTB,varx	 ;

        ldi	Displaycnt,0     ;Reset displaycnt if nothing selected
        ldi     Dispstate,0      ;Reset display status if nothing selected
	
        mov     varX,Display5
        swap    varX
        or      varX,Display4        
        cpi     varX,6
        brsh    SubTuneL0
       	rjmp	Main_loop        ;Return if lower than 6 MHz
SubTuneL0:
        rcall   SubStep          ;Set the frequency step size         
        sub     SUMreg0,varX     ;Substract without carry
        sbc     SUMreg1,varY     ;Substract with carry
        sbc     SUMreg2,varZ     ;Substract with carry
        sbc     SUMreg3,Zero

        rcall   subAdd8x

        cpi     Speed,0 
        brne    SubTuneL1
        subi    Display0,1       ;Substract 15.625Hz
SubTuneL1:
        cpi     Speed,1 
        brne    SubTuneL2
        subi    Display0,2       ;Substract 31.25Hz
SubTuneL2:
        cpi     Speed,2 
        brne    SubTuneL3
        subi    Display0,4       ;Substract 125Hz
SubTuneL3:
        cpi     Speed,3 
        brne    SubTuneL4
        subi    Display1,1       ;Substract 1kHz
SubTuneL4:
        cpi     Speed,4 
        brne    SubTuneL5
        subi    Display2,1       ;Substract 10kHz
SubTuneL5:
        cpi     Speed,5 
        brne    SubTuneL6
        subi    Display3,1       ;Substract 100kHz
SubTuneL6:

SubLreg:                         ;Correct the registers
        sbrc    Display0,7       ;Correct the next registers for overflow
        dec     Display1
        sbrc    Display1,7
        dec     Display2
        sbrc    Display2,7
        dec     Display3
        sbrc    Display3,7
        dec     Display4
        sbrc    Display4,7
        dec     Display5

        sbrc    Display0,7       ;Correct the registers in range             
        subi    Display0,-64     
        sbrc    Display1,7                
        subi    Display1,-10     
        sbrc    Display2,7                
        subi    Display2,-10     
        sbrc    Display3,7                
        subi    Display3,-10     
        sbrc    Display4,7                
        subi    Display4,-10     
        sbrc    Display5,7                
        subi    Display5,-10     

        rcall   subAdd8x

        ldi     varX,13
SubLregDelay:
        dec     varX
        brne    SubLregDelay
        nop
        nop
	rjmp	Main_loop 


SubTuneH:
        ldi	Speedcnt,0       ;Reset Speedcnt if nothing selected
        ldi     varX,0b11111111  ;Set B0-7 to off state for LED
        out     PORTB,varx	 ;

        ldi	Displaycnt,0     ;Reset displaycnt if nothing selected
        ldi     Dispstate,0      ;Reset display status if nothing selected
	
        mov     varX,Display5
        swap    varX
        or      varX,Display4        
        cpi     varX,48
        brlo    SubTuneH0
	rjmp	Main_loop        ;Return if higher than 30 MHz
SubTuneH0:
        rcall   SubStep          ;Set the frequency step size         
        add     SUMreg0,varX     ;Add without carry
        adc     SUMreg1,varY     ;Add with carry
        adc     SUMreg2,varZ     ;Add with carry
        adc     SUMreg3,Zero

        rcall   subAdd8x

        subi    Display0,-192    ;Add values to be able to use carry overflow in the calculations
        subi    Display1,-246
        subi    Display2,-246
        subi    Display3,-246
        subi    Display4,-246
        subi    Display5,-246

        cpi     Speed,0 
        brne    SubTuneH1
        subi    Display0,-1       ;Add 15.625Hz
SubTuneH1:
        cpi     Speed,1 
        brne    SubTuneH2
        subi    Display0,-2       ;Add 31.25Hz
SubTuneH2:
        cpi     Speed,2 
        brne    SubTuneH3
        subi    Display0,-4       ;Add 125Hz
SubTuneH3:
        cpi     Speed,3 
        brne    SubTuneH4
        subi    Display1,-1       ;Add 1kHz
SubTuneH4:
        cpi     Speed,4 
        brne    SubTuneH5
        subi    Display2,-1       ;Add 10kHz
SubTuneH5:
        cpi     Speed,5 
        brne    SubTuneH6
        subi    Display3,-1       ;Add 100kHz
SubTuneH6:


SubHreg:                         ;Correct the registers
        sbrs    Display0,7       ;Correct the next registers for overflow
        inc     Display1
        sbrs    Display1,7
        inc     Display2
        sbrs    Display2,7
        inc     Display3
        sbrs    Display3,7
        inc     Display4
        sbrs    Display4,7
        inc     Display5

        sbrc    Display0,7       ;Correct the registers in range             
        subi    Display0,192    
        sbrc    Display1,7                
        subi    Display1,246     
        sbrc    Display2,7              
        subi    Display2,246    
        sbrc    Display3,7                
        subi    Display3,246     
        sbrc    Display4,7                
        subi    Display4,246     
        sbrc    Display5,7                
        subi    Display5,246     

        rcall   subAdd8x

        ldi     varX,11
SubHregDelay:
        dec     varX
        brne    SubHregDelay

	rjmp	Main_loop 




SubSpeed:
        rjmp    SubSpeed0        ;Timing correction
SubSpeed0:
        ldi	Displaycnt,0     ;Reset displaycnt when speed is selected
        ldi     Dispstate,0      ;Reset display status when speed is selected
	rcall   subAdd8x         ;DDS 8x 
	mov	varX,Speed       ;Display the current speed 
	rcall	sub7segval       ;Set 7 segments value
        out	PORTB,varY
	inc	Speedcnt	 ;Increment speed if Speedcnt=N
	cpi	Speedcnt,12
	brsh	SubSpeed1

        ldi     varX,2


SubSpeed0Delay:
        dec     varX
        brne    SubSpeed0Delay

        rjmp	Main_loop        ;return without speed change

SubSpeed1:
	ldi	Speedcnt,0	 ;Reset for next period
	inc	Speed            ;Increment speed
	cpi	Speed,6          ;If > 5 then reset to 0
	brlo	SubSpeed2
	ldi	Speed,0
SubSpeed2:
        rjmp	Main_loop        ;return with speed change
	



SubDisplay:
	rcall   subAdd8x         ;DDS 8x
        ldi	Speedcnt,0       ;Reset speedcnt when display is selected
        cpi     Displaycnt,0
        brne    SubNodisplay

SubDisplayStart:
        ldi     varX,255         ;Load out of range for display off
	ldi     Displaycnt,1     ;Load with pause, display off for N periods

SubDisplayStart0:
        cpi     Speed,4          ;Check speed for MHz / kHz display
        brlo    SubDisplaykHz    ;if fast, display MHz, else kHz

subDisplayMHz:
        cpi     Dispstate,1      ;State 1
	brne    SubDisplayMHz3   ;If not then skip
        mov     varX,Display5    ;Load digit 1 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplayMHz3:
        cpi     Dispstate,3      ;State 3
	brne    SubDisplayMHz5   ;If not then skip
        mov     varX,Display4    ;Load digit 2 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplayMHz5:
        cpi     Dispstate,5      ;State 5
	brne    SubDisplayMHz6   ;If not then skip
        mov     varX,Display3    ;Load digit 3 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplayMHz6:
        rjmp    subDisplayValue  ;

subDisplaykHz:
        nop
        cpi     Dispstate,1      ;State 1
	brne    SubDisplaykHz3   ;If not then skip
        mov     varX,Display3    ;Load digit 1 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplaykHz3:
        cpi     Dispstate,3      ;State 3
	brne    SubDisplaykHz5   ;If not then skip
        mov     varX,Display2    ;Load digit 2 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplaykHz5:
        cpi     Dispstate,5      ;State 5
	brne    SubDisplaykHz6   ;If not then skip
        mov     varX,Display1    ;Load digit 3 to display
	ldi     Displaycnt,3     ;on for N periods
subDisplaykHz6:


subDisplayValue:
        rcall   sub7segval       ;Set value for 7 segment
        out	PORTB,varY       ;Set output port to digit
	inc	Dispstate        ;Increment Display state
	andi	Dispstate,0b00001111 ;If > 15 then reset to 0

subDisplayCorrection_state:
        cpi     Displaycnt,1     ;If pauze then correction for subDisplay routines / Dispstate
        brne    subDisplayCorrection;
        rjmp    SubDisplayCorrection;

subDisplayCorrection:	         ;Extra correction for too many cycles 
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB now only one too much for kHz display
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 
 
        add     DDSreg0,SUMreg0  ;Add the sumregisters to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB now only one too much for kHz display
nop
nop 
        rjmp    Main_loop        ;Goto Main_loop after display of new digit

subNoDisplay:
        ldi     varX,16          ;Delay 3x varX=46
subNoDisplay0_del:
        dec     varX
        brne    SubNoDisplay0_del
        
        dec     Displaycnt       ;Decrement Displaycnt if not zero and no actions
        rjmp    Main_loop        ;Goto Main_loop without any action




;==============================================================================================
sub7segval:		         ; Calculate 7 segments port value
        cpi	varX,0
	brne	sub7segval1
	ldi	varY,0b10000000
sub7segval1:
	cpi	varX,1
	brne	sub7segval2
	ldi	varY,0b11110010
sub7segval2:
	cpi	varX,2
	brne	sub7segval3
	ldi	varY,0b01001000
sub7segval3:
	cpi	varX,3
	brne	sub7segval4
	ldi	varY,0b01100000
sub7segval4:
	cpi	varX,4
	brne	sub7segval5
	ldi	varY,0b00110010
sub7segval5:
	cpi	varX,5
	brne	sub7segval6
	ldi	varY,0b00100100
sub7segval6:
	cpi	varX,6
	brne	sub7segval7
	ldi	varY,0b00000100
sub7segval7:
	cpi	varX,7
	brne	sub7segval8
	ldi	varY,0b11110000
sub7segval8:
	cpi	varX,8
	brne 	sub7segval9
	ldi	varY,0b00000000
sub7segval9:
	cpi	varX,9
	brne	sub7segval10
	ldi	varY,0b00100000
sub7segval10:
	cpi	varX,10
	brlo	sub7segval11
	ldi	varY,0b11111111  ;All off character 255
sub7segval11:
	ret





subAdd8x:			 ;Add DDS 8x normal value for 1/8 of the normal speed operation
                 		 	
        lsl	SUMreg0		 ;X2 + carry
	rol	SUMreg1
	rol	SUMreg2
	rol	SUMreg3
        rol	SUMreg0		 ;X4 + carry
	rol	SUMreg1
	rol	SUMreg2
	rol	SUMreg3
        rol	SUMreg0		 ;X8 + carry
	rol	SUMreg1
	rol	SUMreg2
	rol	SUMreg3
  

	add     DDSreg0,SUMreg0  ;Add the sumregisters 8x to the DDS register 
        adc     DDSreg1,SUMreg1
        adc     DDSreg2,SUMreg2
        adc     DDSreg3,SUMreg3  ;MSB
        mov     varX,DDSreg3     ;MSByte in varX 
        sbrc    varX,7           ;Generate down ramp if bit7=1
        com     varX
        out     PORTD,varX       ;To A/D output PORTD 

        lsr	SUMreg3		 ;/2 + carry
	ror	SUMreg2
	ror	SUMreg1
	ror	SUMreg0
        ror	SUMreg3		 ;/4 + carry
	ror	SUMreg2
	ror	SUMreg1
	ror	SUMreg0
        ror	SUMreg3		 ;/8 + carry
	ror	SUMreg2
	ror	SUMreg1
	ror	SUMreg0

	ret			 



SubStep:        		 ;Set varX, varY and varZ to the step value
        cpi     Speed,0          ;71 is 15.625 Hz step
        brne    SubStep1
        ldi     varX,71
        ldi     varY,0
        ldi     varZ,0
SubStep1:
        cpi     Speed,1          ;142 is 31.25 Hz step
        brne    SubStep2
        ldi     varX,142
        ldi     varY,0
        ldi     varZ,0
SubStep2:
        cpi     Speed,2          ;284 is 125 Hz step
        brne    SubStep3
        ldi     varX,0x1C
        ldi     varY,0x1
        ldi     varZ,0
SubStep3:
        cpi     Speed,3          ;4544 is 1 kHz step
        brne    SubStep4
        ldi     varX,0xC0
        ldi     varY,0x11
        ldi     varZ,0
SubStep4:
        cpi     Speed,4          ;45440 is 10 kHz step
        brne    SubStep5
        ldi     varX,0x80
        ldi     varY,0xB1
        ldi     varZ,0
SubStep5:
        cpi     Speed,5          ;454400 is 100 kHz step
        brne    SubStep6
        ldi     varX,0x00
        ldi     varY,0xEF
        ldi     varZ,06
SubStep6:
        ret